// vip defines the ports, but not the HDL paths
package vip;
  import uvm_pkg::*;
  import aop_pkg::*; 
  import smp_pkg::*;

  `include "uvm_macros.svh"

  class vip_component extends aop_component;

    `uvm_component_utils(vip_component)

    smp_port#(1) req;
    smp_port#(1) ack;

    function new(string name, uvm_component parent = null);
      super.new(name, parent);
    endfunction

    function void build_phase(uvm_phase phase);
      super.build_phase(phase);

      req = smp_port#(bit)::type_id::create("req", this);
      ack = smp_port#(bit)::type_id::create("ack", this);
    endfunction

    task main_phase(uvm_phase phase);
      $display("%s value at time %0d is %d", req.get_hdl_path(), $time, req.get());
      $display("%s value at time %0d is %d", ack.get_hdl_path(), $time, ack.get());
      #1;
      $display("%s value at time %0d is %d", req.get_hdl_path(), $time, req.get());
      $display("%s value at time %0d is %d", ack.get_hdl_path(), $time, ack.get());
      #2;
      $display("%s value at time %0d is %d", req.get_hdl_path(), $time, req.get());
      $display("%s value at time %0d is %d", ack.get_hdl_path(), $time, ack.get());
      #1;
      req.set(0);
      ack.set(0);
      #1;
      $display("%s value at time %0d is %d", req.get_hdl_path(), $time, req.get());
      $display("%s value at time %0d is %d", ack.get_hdl_path(), $time, ack.get());
    endtask
  endclass

  class vip_env extends aop_env;

    `uvm_component_utils(vip_env)

    vip_component comp;

    function new(string name, uvm_component parent = null);
      super.new(name, parent);
    endfunction

    function void build_phase(uvm_phase phase);
      super.build_phase(phase);

      comp = vip_component::type_id::create("comp", this);      
    endfunction

  endclass
endpackage

  