
// integrates the vip into a testbench. defines the hdl_paths for signals
package vip_integration;
  import uvm_pkg::*;
  import aop_pkg::*;
  import smp_pkg::*;
  import vip::*;

  `include "uvm_macros.svh"


  class test_base extends aop_test;
    `uvm_component_utils(test_base)

    vip_env my_vip1, my_vip2;

    function new(string name, uvm_component parent = null);
      super.new(name, parent);
    endfunction

    function void build_phase(uvm_phase phase);
      super.build_phase(phase);

      uvm_config_db#(string)::set(this, "my_vip1", "hdl_path", "verilog_top");
      uvm_config_db#(string)::set(this, "my_vip1.comp", "hdl_path", "verilog_block_i");

      uvm_config_db#(string)::set(this, "my_vip1.comp.req", "hdl_path", "req");
      uvm_config_db#(signal_hdl)::set(this, "my_vip1.comp.req", "sig_hdl", Verilog);
      uvm_config_db#(signal_net)::set(this, "my_vip1.comp.req", "sig_net", Verilog_reg);

      uvm_config_db#(string)::set(this, "my_vip1.comp.ack", "hdl_path", "ack");
      uvm_config_db#(signal_hdl)::set(this, "my_vip1.comp.ack", "sig_hdl", Verilog);
      uvm_config_db#(signal_net)::set(this, "my_vip1.comp.ack", "sig_net", Verilog_wire);


      uvm_config_db#(string)::set(this, "my_vip2", "hdl_path", "vhdl_top");
      uvm_config_db#(string)::set(this, "my_vip2.comp", "hdl_path", "vhdl_block_i");

      uvm_config_db#(string)::set(this, "my_vip2.comp.req", "hdl_path", "req");
      uvm_config_db#(signal_hdl)::set(this, "my_vip2.comp.req", "sig_hdl", Verilog);
      uvm_config_db#(signal_net)::set(this, "my_vip2.comp.req", "sig_net", Verilog_wire);

      uvm_config_db#(string)::set(this, "my_vip2.comp.ack", "hdl_path", "ack");
      uvm_config_db#(signal_hdl)::set(this, "my_vip2.comp.ack", "sig_hdl", Verilog);
      uvm_config_db#(signal_net)::set(this, "my_vip2.comp.ack", "sig_net", Verilog_wire);       

      my_vip1 = vip_env::type_id::create("my_vip1", this);
      my_vip2 = vip_env::type_id::create("my_vip2", this);       
    
    endfunction

    task main_phase(uvm_phase phase);
      phase.raise_objection(this, "bla");      
      #10;
      phase.drop_objection(this, "bla");
    endtask
  endclass
endpackage

